/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.batch.functionsample.sample000;

import java.util.Random;
import jp.terasoluna.fw.batch.openapi.BLogicResult;
import jp.terasoluna.fw.batch.openapi.JobContext;
import jp.terasoluna.fw.batch.openapi.ReturnCode;
import jp.terasoluna.fw.batch.openapi.SupportLogic;
import jp.terasoluna.fw.dao.UpdateDAO;
import jp.terasoluna.batch.functionsample.common.SeikyuData;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * サポートクラス。<br>
 * 請求テーブルのデータをクリアし、新規データを作成する。<br>
 * データ件数は10件であり、内容はランダムで作成する。<br>
 */
public class Sample000PreLogic04 implements SupportLogic<JobContext> {

    /**
     * 顧客
     */
    static final String[] aryCustname = {"A店","B店","C店","D店","E店","F店","G店","H店","I店","J店","K店"};
    
    /**
     * ログクラス。
     */
    private static final Log log = LogFactory.getLog(Sample000PreLogic04.class);

    /**
     * 支店
     */
    private static final String[] aryBranchcd = {"千葉","埼玉"};
    
    /**
     * 担当者
     */
    private static final String[] aryTantosyaid = {"田中","佐藤","鈴木","渡辺","井上"};
    	
    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private UpdateDAO updateDAO;
    
    /**
     * 処理を起動する。
     */
    public BLogicResult execute(JobContext jobContext) {

    if(log.isDebugEnabled()){
        log.debug("start.");
    }
    
    //請求テーブルのデータを削除。
    updateDAO.execute("SAMPLE000.deleteSeikyu", null);
        
    //請求テーブルにデータを挿入する。
    SeikyuData seikyu  = new SeikyuData();
    Random random = new Random();
    int tantosyaNo = 0;
    int custNo = 0;
    for(String branchcd : aryBranchcd){
        
        seikyu.setBranchcd(branchcd);
        tantosyaNo = 0;
        
        for(int j = 1; j <= 5; j++){
        seikyu.setCustname(aryCustname[custNo]);
        	seikyu.setSeikyutuki("2007/0" + j);
        	seikyu.setSeikyugaku(random.nextInt(100000) + 10000);
        	seikyu.setTantosyaid(aryTantosyaid[tantosyaNo]);
        	    
        	updateDAO.execute("SAMPLE000.insertSeikyu", seikyu);
        	custNo += random.nextInt(2);
        	tantosyaNo += random.nextInt(2);
        }
        custNo++;

    }
    
    if(log.isDebugEnabled()){
        log.debug("end.");
    }
    
    return new BLogicResult(ReturnCode.NORMAL_CONTINUE);
    }

    /**
     * UpdateDAOを設定する。
     * @param updateDAO 設定するUpdateDAO
     */
    public void setUpdateDAO(UpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }
    

}
